;*****************  ***********************
.NOLIST
.include "tn15def.inc"
.LIST
; 
; PB0   - MOSI
; PB1   -  Up, Vref=1,22v (MISO)
; PB2   - INT0 (SCK)
; PB3   - OUT
; PB4   - -
; PB5   - RST

.equ  LED     =PB3 ; OUT

; 
.equ  Tdead  =$08  ; - . TMR1   (F/4)
; (1/1,6)*256*4*8=640*8=5120 mks -  
.equ  CALIBR =$1FF ;  . 

          .org  $0000

          rjmp  BEGIN
          rjmp  Inter0  ; . INT0
          nop           ;  
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
; 
BEGIN:    cli               ; .  .
          ldi   R16,$0E      ; 0000.1110
          out   WDTCR,R16   ; . WDT  0,6
          wdr               ;  WDT
          clr   R16
          out   MCUSR,R16   ;   RESET
          out   TIMSK,R16   ;  . 
          out   TCCR0,R16   ;  TMR0
          out   SFIOR,R16
          out   EECR,R16    ;  EEPROM
          out   ADMUX,R16   ; . ADC
          out   ADCSR,R16   ; /
          ldi   R16,$50     ; 0101.0000
          out   ACSR,R16    ; PB1 = -, Vref = +1,22v
          ldi   R16,$7
          out   TCCR1,R16   ; TMR1=CK/4, start
          ldi   R16,$40
          out   GIMSK,R16   ; . . INT0
          ldi   R16,$43     ; SLEEP - dis, IDL, . . _|
          out   MCUCR,R16
          ldi   ZH,high(CALIBR*2+1)
          ldi   ZL,low(CALIBR*2+1) ;  . 
          lpm
          mov   R16,R0
          cpi   R16,$FF
          brne  PC+2        ; < FF
          ldi   R16,$70     ;   
          out   OSCCAL,R16  ; . 
          clr   R16
          out   PORTB,R16   ; PORTB=0
          ldi   R16,$08     ; 0000.1000
          out   DDRB,R16    ; PB3-OUT
          sbis  ACSR,ACO    ; Up - OK
          rjmp  PC-1        ;  Up
          clr   R16
          out   TCNT1,R16   ;  TMR1
          ldi   R16,$04     ; 0000.0100
          out   TIFR,R16    ;  . TMR1
          ldi   R18,$FF     ; . . . .
          sei               ; . .
;  
CIKL:     in    R16,TIFR
          sbrs  R16,TOV1
          rjmp  CIKL        ;  . TMR1
          ldi   R16,$04     ; 0000.0100
          out   TIFR,R16    ;  . TMR1
          wdr
          cpi   R18,$FF
          breq  CIKL
          inc   R18
          rjmp  CIKL        ;  .

;  INT0
; :  R18 - . - . TMR1 (. .)
; : R18 -  - . TMR1
;  R20,21
Inter0:   in    R21,SREG    ; 
          sbic  ACSR,ACO    ; Up > Umax
          sbi   PORTB,LED   ; Up < Umax, . LED
          clr   R20
          out   TCNT1,R20   ;  TMR1
          ldi   R20,$04     ; 0000.0100
          out   TIFR,R20    ;  . TMR1
          mov   R20,R18     ; . .
Inter1:   dec   R20         ; 1
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
          brne  Inter1      ; 2 R18*(3...11)/1,6=1,875...6,875mks
          cbi   PORTB,LED   ; . LED
          clr   R18
Inter2:   in    R20,TIFR
          sbrs  R20,TOV1
          rjmp  Inter2      ;  . TMR1
          ldi   R20,$04     ; 0000.0100
          out   TIFR,R20    ;  . TMR1
          inc   R18
          cpi   R18,Tdead   ; R16-Tdead
          brcs  Inter2      ; R16 < Tdead, 
          ldi   R20,$60     ; 0110.0000
          out   GIFR,R20    ;    . 
          out   SREG,R21    ; 
          reti

